unit FinalEffect;

interface

uses
  SysUtils;

type
  FinalEffects = class
  private
    file_name: String;
    focal_point: Integer;
    list_name: String;
    new_name: String;
    no_removing: Boolean;
    no_searching: Boolean;
    normal: AnsiString;
    path_name: String;
    selected_directory_has_priority: Boolean;
    substitute: AnsiString;
    surrogate_pair_to_underline: Boolean;
    which_table: Boolean;
  public
    function atPoint: Integer;
    function fileName: String;
    function listName: String;
    function newName: String;
    function noRemoving: Boolean;
    function normalCharacter: AnsiString;
    function noSearching: Boolean;
    function pathName: String;
    function priority: Boolean;
    function substituteCharacter: AnsiString;
    function surrogatePairToUnderline: Boolean;
    function whichTable: Boolean;
    procedure setting(EMPTY_ANSI: AnsiString); overload;
    procedure setting(fn: String; LN: String; nn: String; pn: String;
      L: AnsiString; u: AnsiString;
      fp: Integer;
      nr: Boolean; ns: Boolean; sd: Boolean; sp: Boolean; wt: Boolean); overload;

  end;

implementation

function FinalEffects.atPoint: Integer;
begin
  Result := focal_point;
end;

function FinalEffects.fileName: String;
begin
  Result := file_name;
end;

function FinalEffects.listName: String;
begin
  Result := list_name;
end;

function FinalEffects.newName: String;
begin
  Result := new_name;
end;

function FinalEffects.noRemoving: Boolean;
begin
  Result := no_removing;
end;

function FinalEffects.normalCharacter: AnsiString;
begin
  Result := normal;
end;

function FinalEffects.noSearching: Boolean;
begin
  Result := no_searching;
end;

function FinalEffects.pathName: String;
begin
  Result := path_name;
end;

function FinalEffects.priority: Boolean;
begin
  Result := selected_directory_has_priority;
end;

function FinalEffects.substituteCharacter: AnsiString;
begin
  Result := substitute;
end;

function FinalEffects.surrogatePairToUnderline: Boolean;
begin
  Result := surrogate_pair_to_underline;
end;

function FinalEffects.whichTable: Boolean;
begin
  Result := which_table;
end;

procedure FinalEffects.setting(EMPTY_ANSI: AnsiString);
begin
{ String }
  file_name := '';
  list_name := '';
  new_name := '';
  path_name := '';

{ AnsiString }
  normal := EMPTY_ANSI;
  substitute := EMPTY_ANSI;

{ Integer }
  focal_point := 1;

{ Boolean }
  no_removing := False;
  no_searching := False;
  selected_directory_has_priority := False;
  which_table := False;
end;

procedure FinalEffects.setting(fn: String; LN: String; nn: String; pn: String;
  L: AnsiString; u: AnsiString;
  fp: Integer;
  nr: Boolean; ns: Boolean; sd: Boolean; sp: Boolean; wt: Boolean);

begin
{ String }
  file_name := fn;
  list_name := LN;
  new_name := nn;
  path_name := pn;

{ AnsiString }
  normal := L;
  substitute := u;

{ Integer }
  focal_point := fp; { at and around the point }

{ Boolean }
  no_removing := nr;
  no_searching := ns;
  selected_directory_has_priority := sd;
  surrogate_pair_to_underline := sp;
  which_table := wt;
end;

end.
