unit PutCSV;

{$I+}

interface

uses
  SysUtils, ErrorText;

type AnsiCharArray = array[0..4095] of AnsiChar;

type
  PutSurroCSV = class
  private
    ANSI_CHAR: array[0..255] of AnsiChar;
    CLEAR_ARRAY: AnsiCharArray;
    combo: AnsiCharArray;
    H_FE_C: AnsiChar;
    H_FF_C: AnsiChar;
    v: AnsiCharArray;
    V_SIZE: Integer;
    V_SIZE_1: Integer;
    x: ErrorTexts;
    new_name: String;
    function ANSI_CHAR_table: AnsiChar;
  public
    function bufferingWriting(comboLength: Integer): Integer;
    function eight_bit_character(b: Byte): AnsiChar;
    procedure setting(nn: String);
  end;

const
  C_ERR = 'err';
  FILE_ERROR = -2;
  H_FE = 254;
  H_FF = 255;
  SIZE_OF_ANSICHAR = 1;
  TEXT_FILE = '.txt';

implementation

function PutSurroCSV.ANSI_CHAR_table: AnsiChar;
var
  beginning_of_ASCII: Integer;
  end_1: Integer;
  h: AnsiChar;
  k: Integer;
  m: Integer;
begin
  beginning_of_ASCII := 0;

  end_1 := H_FF - 1;
  ANSI_CHAR[0] := #0;
  h := ANSI_CHAR[0];
  m := 1;

  for k := beginning_of_ASCII to end_1 do
  begin
    Inc(h);
    ANSI_CHAR[m] := h;
    Inc(m);
  end;

  Result := h; { H_FF_C }
end;

function PutSurroCSV.bufferingWriting(comboLength: Integer): Integer;
var
  block_has_been_written: Integer;
  exit_code: Integer;
  k: Integer;
  n: Integer;
  newFile: File;
  s: String;
begin
  exit_code := 0;
  n := 0;

{ Writing }
  try
    AssignFile(newFile, new_name);
    Rewrite(newFile, SIZE_OF_ANSICHAR);

    repeat
      v := CLEAR_ARRAY;

      for k := 0 to V_SIZE_1 do
      begin
        v[k] := combo[n];
        Inc(n);
        if n >= comboLength then
          begin
            V_SIZE := k + 1;
            V_SIZE_1 := V_SIZE - 1;
            break;
          end;

      end;

      BlockWrite(newFile, v, V_SIZE, block_has_been_written);
    until n >= comboLength;

    CloseFile(newFile);
    V_SIZE := SizeOf(v);
    V_SIZE_1 := V_SIZE - 1;
  except
    s := 'Rewrite() error-53: ' + new_name;
    x := ErrorTexts.Create;
    x.setting(C_ERR, TEXT_FILE, s);
    x.Free;
    exit_code := FILE_ERROR;
  end;

  Result := exit_code;
end;

function PutSurroCSV.eight_bit_character(b: Byte): AnsiChar;
var
  beginning_of_ASCII: Integer;
  end_1: Integer;
  h: AnsiChar;
  k: Integer;
begin
  beginning_of_ASCII := 0;

  if b >= 1 then
    begin
      end_1 := b - 1;
      h := AnsiChar( Chr(beginning_of_ASCII) );

      for k := beginning_of_ASCII to end_1 do
      begin
        Inc(h);
      end;

    end
  else
    begin
      h := AnsiChar(#0);
    end;

  Result := h;
end;

procedure PutSurroCSV.setting(nn: String);
var
  i: Integer;
  m: Integer;
begin
  new_name := nn;

  V_SIZE := SizeOf(v);
  V_SIZE_1 := V_SIZE - 1;

  for i := 0 to V_SIZE_1 do
  begin
    CLEAR_ARRAY[i] := #0;
  end;

{ Characters of AnsiChar type }
  H_FF_C := ANSI_CHAR_table;
  H_FE_C := ANSI_CHAR[H_FE];

  m := 0;
  combo[m] := H_FF_C; Inc(m);
  combo[m] := H_FE_C; Inc(m);
  combo[m] := ANSI_CHAR[95]; Inc(m);
  combo[m] := ANSI_CHAR[216]; Inc(m);
  combo[m] := ANSI_CHAR[160]; Inc(m);
  combo[m] := ANSI_CHAR[221]; Inc(m);
  combo[m] := ANSI_CHAR[44]; Inc(m);
  combo[m] := ANSI_CHAR[0]; Inc(m);
  combo[m] := ANSI_CHAR[68]; Inc(m);
  combo[m] := ANSI_CHAR[0]; Inc(m);
  combo[m] := ANSI_CHAR[56]; Inc(m);
  combo[m] := ANSI_CHAR[0]; Inc(m);
  combo[m] := ANSI_CHAR[53]; Inc(m);
  combo[m] := ANSI_CHAR[0]; Inc(m);
  combo[m] := ANSI_CHAR[70]; Inc(m);
  combo[m] := ANSI_CHAR[0]; Inc(m);
  combo[m] := ANSI_CHAR[44]; Inc(m);
  combo[m] := ANSI_CHAR[0]; Inc(m);
  combo[m] := ANSI_CHAR[68]; Inc(m);
  combo[m] := ANSI_CHAR[0]; Inc(m);
  combo[m] := ANSI_CHAR[68]; Inc(m);
  combo[m] := ANSI_CHAR[0]; Inc(m);
  combo[m] := ANSI_CHAR[65]; Inc(m);
  combo[m] := ANSI_CHAR[0]; Inc(m);
  combo[m] := ANSI_CHAR[48]; Inc(m);
  combo[m] := ANSI_CHAR[0]; Inc(m);
  combo[m] := ANSI_CHAR[44]; Inc(m);
  combo[m] := ANSI_CHAR[0]; Inc(m);
  combo[m] := ANSI_CHAR[50]; Inc(m);
  combo[m] := ANSI_CHAR[0]; Inc(m);
  combo[m] := ANSI_CHAR[55]; Inc(m);
  combo[m] := ANSI_CHAR[0]; Inc(m);
  combo[m] := ANSI_CHAR[68]; Inc(m);
  combo[m] := ANSI_CHAR[0]; Inc(m);
  combo[m] := ANSI_CHAR[65]; Inc(m);
  combo[m] := ANSI_CHAR[0]; Inc(m);
  combo[m] := ANSI_CHAR[48]; Inc(m);
  combo[m] := ANSI_CHAR[0]; Inc(m);
  combo[m] := ANSI_CHAR[44]; Inc(m);
  combo[m] := ANSI_CHAR[0]; Inc(m);
  combo[m] := ANSI_CHAR[51]; Inc(m);
  combo[m] := ANSI_CHAR[0]; Inc(m);
  combo[m] := ANSI_CHAR[49]; Inc(m);
  combo[m] := ANSI_CHAR[0]; Inc(m);
  combo[m] := ANSI_CHAR[44]; Inc(m);
  combo[m] := ANSI_CHAR[0]; Inc(m);
  combo[m] := ANSI_CHAR[52]; Inc(m);
  combo[m] := ANSI_CHAR[0]; Inc(m);
  combo[m] := ANSI_CHAR[49]; Inc(m);
  combo[m] := ANSI_CHAR[0]; Inc(m);
  combo[m] := ANSI_CHAR[52]; Inc(m);
  combo[m] := ANSI_CHAR[0]; Inc(m);
  combo[m] := ANSI_CHAR[44]; Inc(m);
  combo[m] := ANSI_CHAR[0]; Inc(m);
  combo[m] := ANSI_CHAR[227]; Inc(m);
  combo[m] := ANSI_CHAR[140]; Inc(m);
  combo[m] := ANSI_CHAR[13]; Inc(m);
  combo[m] := ANSI_CHAR[0]; Inc(m);
  combo[m] := ANSI_CHAR[10]; Inc(m);
  combo[m] := ANSI_CHAR[0]; Inc(m);

  bufferingWriting(m);
end;

end.
