unit Substitute;

interface

uses
  SysUtils;

type
  NormalSubstitute = class
  private
    normal: AnsiString;
    please_check: Boolean;
    substitute: AnsiString;
  public
    function normalCharacter: AnsiString;
    function pleaseCheck: Boolean;
    function substituteCharacter: AnsiString;
    procedure setting(EMPTY_ANSI: AnsiString; n: AnsiChar; s: AnsiChar; p: Boolean); overload;
    procedure setting(n: AnsiString; s: AnsiString; p: Boolean); overload;
    procedure sure;
  end;

implementation

function NormalSubstitute.normalCharacter: AnsiString;
begin
  Result := normal;
end;

function NormalSubstitute.pleaseCheck: Boolean;
begin
  Result := please_check;
end;

function NormalSubstitute.substituteCharacter: AnsiString;
begin
  Result := substitute;
end;

procedure NormalSubstitute.setting(EMPTY_ANSI: AnsiString; n: AnsiChar; s: AnsiChar; p: Boolean);
begin
  normal := EMPTY_ANSI + n;
  substitute := EMPTY_ANSI + s;
  please_check := p;
end;

procedure NormalSubstitute.setting(n: AnsiString; s: AnsiString; p: Boolean);
begin
  normal := n;
  substitute := s;
  please_check := p;
end;

procedure NormalSubstitute.sure;
begin
  please_check := False;
end;

end.
