unit FieldsArrayMany;

interface

uses
  SysUtils, ErrorText;

type
  FieldsListMany = class
  private
    count: Integer;
    EMPTY_ANSI: AnsiString;
    fields_list: array[0..3071] of AnsiString;
  public
    function item(i: Integer): AnsiString;
    function itemCount: Integer;
    procedure setting(s: AnsiString; i: Integer);
  end;

const
  C_ERR = 'err';
  UPPER_LIMIT_TO_FIELD_NUMBER = 3071;
  TEXT_FILE = '.txt';

implementation

function FieldsListMany.item(i: Integer): AnsiString;
var
  x: ErrorTexts;
  z: AnsiString;
begin
  z := EMPTY_ANSI;

  if i < 0 then
    begin
      x := ErrorTexts.Create;
      x.setting(C_ERR, TEXT_FILE, 'item() error-105: i < 0');
      x.Free;
    end
  else
    begin
      if i >= UPPER_LIMIT_TO_FIELD_NUMBER then
        begin
          x := ErrorTexts.Create;
          x.setting(C_ERR, TEXT_FILE, 'item() error-106: >= UPPER_LIMIT_TO_FIELD_NUMBER');
          x.Free;
        end
      else
        begin
          z := fields_list[i];
        end;

    end;

  Result := z;
end;

function FieldsListMany.itemCount: Integer;
begin
  Result := count;
end;

procedure FieldsListMany.setting(s: AnsiString; i: Integer);
var
  x: ErrorTexts;
begin
  EMPTY_ANSI := '';

  if i < 0 then
    begin
      x := ErrorTexts.Create;
      x.setting(C_ERR, TEXT_FILE, 'item() error-107: i < 0');
      x.Free;
    end
  else
    begin
      if i >= UPPER_LIMIT_TO_FIELD_NUMBER then
        begin
          x := ErrorTexts.Create;
          x.setting(C_ERR, TEXT_FILE, 'item() error-108: >= UPPER_LIMIT_TO_FIELD_NUMBER');
          x.Free;
        end
      else
        begin
          fields_list[i] := s;
          Inc(count);
        end;

    end;

end;

end.
