unit FinalEffect;

interface

uses
  SysUtils;

type
  FinalEffects = class
  private
    carriage_return: Boolean;
    file_name: String;
    identical_time: Boolean;
    new_name: String;
    no_removing: Boolean;
    no_searching: Boolean;
    path_name: String;
    point: Integer;
    remove_0Dh: Boolean;
    remove_controllers: Boolean;
    selected_directory_has_priority: Boolean;
    temporary_binary: Boolean;
    which_table: Boolean;
  public
    function atPoint: Integer;
    function carriageReturn: Boolean;
    function fileName: String;
    function identicalTime: Boolean;
    function newName: String;
    function noRemoving: Boolean;
    function noSearching: Boolean;
    function pathName: String;
    function priority: Boolean;
    function produceTemporaryBinary: Boolean;
    function remove0Dh: Boolean;
    function removeControllers: Boolean;
    function whichTable: Boolean;
    procedure setting(f: String; nn: String; t: String; 
      aa: Integer; 
      i: Boolean; it: Boolean; nr: Boolean; n: Boolean; r0: Boolean; rc: Boolean; s: Boolean; tb: Boolean; w: Boolean);

  end;

implementation

function FinalEffects.atPoint: Integer;
begin
  Result := point;
end;

function FinalEffects.carriageReturn: Boolean;
begin
  Result := carriage_return;
end;

function FinalEffects.fileName: String;
begin
  Result := file_name;
end;

function FinalEffects.identicalTime: Boolean;
begin
  Result := identical_time;
end;

function FinalEffects.newName: String;
begin
  Result := new_name;
end;

function FinalEffects.noRemoving: Boolean;
begin
  Result := no_removing;
end;

function FinalEffects.noSearching: Boolean;
begin
  Result := no_searching;
end;

function FinalEffects.pathName: String;
begin
  Result := path_name;
end;

function FinalEffects.priority: Boolean;
begin
  Result := selected_directory_has_priority;
end;

function FinalEffects.produceTemporaryBinary: Boolean;
begin
  Result := temporary_binary;
end;

function FinalEffects.remove0Dh: Boolean;
begin
  Result := remove_0Dh;
end;

function FinalEffects.removeControllers: Boolean;
begin
  Result := remove_controllers;
end;

function FinalEffects.whichTable: Boolean;
begin
  Result := which_table;
end;

procedure FinalEffects.setting(f: String; nn: String; t: String; 
  aa: Integer; 
  i: Boolean; it: Boolean; nr: Boolean; n: Boolean; r0: Boolean; rc: Boolean; s: Boolean; tb: Boolean; w: Boolean);

begin
{ String }
  file_name := f;
  new_name := nn;
  path_name := t;

{ Integer }
  point := aa; { at and around the point }

{ Boolean }
  carriage_return := i;
  identical_time := it;
  no_removing := nr;
  no_searching := n;
  remove_0Dh := r0;
  remove_controllers := rc;
  selected_directory_has_priority := s;
  temporary_binary := tb;
  which_table := w;
end;

end.
