unit Guide;

interface

uses
  SysUtils;

type
  Guiding = class
  public
    procedure versionGuide(v: String; comments: Boolean);
  end;

const
  VERSION_TEXT = 'version.txt';

implementation

procedure Guiding.versionGuide(v: String; comments: Boolean);
begin
  WriteLn( 'Eucsjis Version ' + v );
  WriteLn('');
  if comments then
    begin
      WriteLn('eucsjis               # Produce EUC-JP~Shift_JIS.bin from MS932~EUC-JP.bin ');
      WriteLn('eucsjis EUC           # Produce eucsjis.txt ');
      WriteLn('eucsjis EUC SJIS      # Produce a new file. ');
      WriteLn('eucsjis -o SJIS EUC   # Produce a new file. ');
      WriteLn('eucsjis --out EUC     # standard output ');
      WriteLn('eucsjis -0 EUC        # Every line includes 0Dh. ');
      WriteLn('eucsjis -t EUC SJIS   # EUC has the same time as SJIS. ');
      WriteLn('eucsjis -a EUC        # Acquire a table name from set_eucsjis.txt ');
      WriteLn('eucsjis -b EUC        # Produce binary.tmp ');
      WriteLn('eucsjis -b EUC EUC    # Produce and rename binary.tmp ');
      WriteLn('eucsjis -b -y EUC     # Do not remove binary.tmp ');
      WriteLn('eucsjis -d EUC        # Do not search a table. ');
      WriteLn('eucsjis -G            # Guide ');
      WriteLn('eucsjis -LF EUC       # 0Dh is removed from every line. ');
      WriteLn('eucsjis -s EUC        # Remove control characters. ');
      WriteLn('eucsjis -w EUC        # -w shows which table eucsjis uses.');
      WriteLn('eucsjis -V            # Version ');
    end
  else
    begin
      WriteLn('eucsjis               ');
      WriteLn('eucsjis EUC           ');
      WriteLn('eucsjis EUC SJIS      ');
      WriteLn('eucsjis -o SJIS EUC   ');
      WriteLn('eucsjis --out EUC     ');
      WriteLn('eucsjis -0 EUC        ');
      WriteLn('eucsjis -t EUC SJIS   ');
      WriteLn('eucsjis -a EUC        ');
      WriteLn('eucsjis -b EUC        ');
      WriteLn('eucsjis -b EUC EUC    ');
      WriteLn('eucsjis -b -y EUC     ');
      WriteLn('eucsjis -d EUC        ');
      WriteLn('eucsjis -G            ');
      WriteLn('eucsjis -LF EUC       ');
      WriteLn('eucsjis -s EUC        ');
      WriteLn('eucsjis -w EUC        ');
      WriteLn('eucsjis -V            ');
    end;

end;

end.
