unit Guide;

interface

uses
  SysUtils;

type
  Guiding = class
  public
    procedure versionGuide(v: String; comments: Boolean);
  end;

const
  VERSION_TEXT = 'version.txt';

implementation

procedure Guiding.versionGuide(v: String; comments: Boolean);
begin
  WriteLn( 'Eucutf16 Version ' + v );
  WriteLn('');
  if comments then
    begin
      WriteLn('eucutf16                # Produce EUC-JP~UTF16.bin ');
      WriteLn('eucutf16 EUC            # Produce eucutf16.txt ');
      WriteLn('eucutf16 EUC UTF16      # Produce a new file. ');
      WriteLn('eucutf16 -o UTF16 EUC   # Produce a new file. ');
      WriteLn('eucutf16 -o UTF16 < EUC # Every line includes 0Dh. ');
      WriteLn('eucutf16 -0 EUC         # Every line includes 0Dh. ');
      WriteLn('eucutf16 -t EUC UTF16   # EUC has the same time as UTF16. ');
      WriteLn('eucutf16 -a EUC         # Acquire a table name from set_eucutf16.txt ');
      WriteLn('eucutf16 -b EUC         # Produce binary.tmp ');
      WriteLn('eucutf16 -b EUC EUC     # Produce and rename binary.tmp ');
      WriteLn('eucutf16 -b -y EUC      # Do not remove binary.tmp ');
      WriteLn('eucutf16 -d EUC         # Do not search a table. ');
      WriteLn('eucutf16 -G             # Guide ');
      WriteLn('eucutf16 -LF EUC        # 0Dh is removed from every line. ');
      WriteLn('eucutf16 -s EUC         # Remove control characters. ');
      WriteLn('eucutf16 -w EUC         # -w shows which table eucutf16 uses.');
      WriteLn('eucutf16 -V             # Version ');
    end
  else
    begin
      WriteLn('eucutf16                ');
      WriteLn('eucutf16 EUC            ');
      WriteLn('eucutf16 EUC UTF16      ');
      WriteLn('eucutf16 -o UTF16 EUC   ');
      WriteLn('eucutf16 -o UTF16 < EUC ');
      WriteLn('eucutf16 -0 EUC         ');
      WriteLn('eucutf16 -t EUC UTF16   ');
      WriteLn('eucutf16 -a EUC         ');
      WriteLn('eucutf16 -b EUC         ');
      WriteLn('eucutf16 -b EUC EUC     ');
      WriteLn('eucutf16 -b -y EUC      ');
      WriteLn('eucutf16 -d EUC         ');
      WriteLn('eucutf16 -G             ');
      WriteLn('eucutf16 -LF EUC        ');
      WriteLn('eucutf16 -s EUC         ');
      WriteLn('eucutf16 -w EUC         ');
      WriteLn('eucutf16 -V             ');
    end;

end;

end.
