unit Divide;

interface

uses
  SysUtils, FieldsArrayHalt, Classes, Ucombo;

type EditFunction = function(s: String): String;
type PettyArray = array[0..255] of Char;

type
  Dividing = class
  protected
    a: TStringList;
    ascii: String;
    ascii_byte: Byte;
    ASCII_C: Char;
    CLEAR_BIT_C: Char;
    combo: String;
    dough: array[0..98303] of Char;
    doughLength: Integer;
    f: FieldsListHalt;
    field_count: Integer;
    GAP_C: Char;
    joint: String;
    joint_byte: Byte;
    JOINT_C: Char;
    manyFields: array[0..3071] of Boolean;
    pattern: array[0..3071] of Char;
    quote: String;
    quote_byte: Byte;
    QUOTE_C: Char;
    remove_separators: Boolean;
    separator: String;
    separator_byte: Byte;
    SEPARATOR_C: Char;
    SET_BIT_C: Char;
    size_of_united_items: Integer;
    procedure vector_to_array_arranging_in_reverse_order;
    procedure vector_to_array_complementing(extra: String; bond: Byte);
    procedure vector_to_array_editing(editing: EditFunction; field_number: Integer);
    procedure vector_to_array_mapping;
  public
    constructor Create;
    destructor Destroy; override;
    function complementing_fields_list(buffer: array of Char; bufferLength: Integer; extra: String; bond: Byte): Integer;
    function editing_field(buffer: array of Char; bufferLength: Integer; field_number: Integer): Integer; virtual;
    function fieldCount: Integer;
    function extracting_decimal_from_field(buffer: array of Char; bufferLength: Integer; field_number: Integer): Integer;
    function extracting_integer_from_field(buffer: array of Char; bufferLength: Integer; field_number: Integer): Integer;
    function leadingCharacters(buffer: array of Char; bufferLength: Integer; character: Char): Integer;
    function mapping_fields_list(buffer: array of Char; bufferLength: Integer): Integer;
    function quoteCode: Byte;
    function reverse_unite(buffer: array of Char; bufferLength: Integer): String;
    function reversing_fields_list(buffer: array of Char; bufferLength: Integer): Integer;
    function search_separator(buffer: array of Char; bufferLength: Integer; beginning: Integer): Integer;
    function separatorCode: Byte;
    function smashed_to_pieces(buffer: array of Char; bufferLength: Integer; selected: array of Boolean): Integer;
    function supplying_bits(c: Integer): String;
    function surge_of_set_bits(c: Integer; interval_0: Integer; interval_1: Integer): String;
    function unite(a: TStringList; c: UniversalComboAppend; buffer: array of Char; bufferLength: Integer): String; overload;
    function unite(buffer: array of Char; bufferLength: Integer): String; overload;
    function unite(buffer: array of Char; bufferLength: Integer; listed: Boolean): String; overload;
    function unitedSize: Integer;
    procedure presetting(s: Byte); overload;
    procedure presetting(q: Byte; s: Byte; e: Boolean); overload; virtual;
    procedure presetting(q: Byte; s: Byte; e: Boolean; a: Byte); overload; virtual;
    procedure setting(fields_list: FieldsListHalt; c: Integer); overload;
    procedure setting(fields_list: FieldsListHalt; c: Integer; pn: array of Char); overload;
    procedure setting_for_extracting;
  end;

const
  CLEAR_BIT = 48; { 30h, '0' }
  COMMA_BYTE = 44; { 2C, ',' }
  EMPTY = '';
  GAP_BYTE = 32; { SP, ' ' }
  H_2E = 46; { dot '.'  }
  H_30 = 48; { '0' }
  H_39 = 57; { '9' }
  MINUS_BYTE = 45;
  N_0TO9_MINUS_SIZE = 11;
  N_0TO9_SIZE = 10;
  NOT_RECOGNIZED = -1;
  SET_BIT = 49; { 31h, '1'}
  STANDARD_QUOTE_BYTE = 34; { 22h, '"' }
  UNDERLINE_BYTE = 95; { 5Fh, '_' }
  UPPER_LIMIT_TO_FIELD_NUMBER = 3071;
  ZERO = '0';

var
  COMMA_C: Char;
  DOT_C: Char;
  MINUS_C: Char;
  N_0TO9: String;
  N_0TO9_MINUS: String;

implementation

function leadingNumbers(full: String): Integer;
var
  c: Char;
  count: Integer;
  found: Boolean;
  fullLength: Integer;
  k: Integer;
  m: Integer;
begin
  count := 0;
  fullLength := Length(full);

  for k := 1 to fullLength do
  begin
    c := full[k];

{ Checking if a number appears. }
    found := False;
    for m := 1 to N_0TO9_SIZE do
    begin
      if N_0TO9[m] = c then
        begin
          found := True;
          break;
        end
      else
        begin
          continue
        end;

    end;

    if found then
      begin
{ Counting numbers }
        Inc(count);
        continue
      end
    else
      begin
        break;
      end;

  end;

  Result := count;
end;

function positiveOrNegativeNumbers(full: String): Integer;
var
  c: Char;
  count: Integer;
  found: Boolean;
  fullLength: Integer;
  k: Integer;
  m: Integer;
begin
  count := 0;
  fullLength := Length(full);

  k := 1;
  c := full[k];

{ Checking if a number or minus appears. }
  found := False;
  for m := 1 to N_0TO9_MINUS_SIZE do
  begin
    if N_0TO9_MINUS[m] = c then
      begin
        found := True;
        break;
      end
    else
      begin
        continue
      end;

  end;

  if found then
    begin
{ Counting numbers }
      Inc(count);

      for k := 2 to fullLength do
      begin
        c := full[k];

{ Checking if a number appears. }
        found := False;
        for m := 1 to N_0TO9_SIZE do
        begin
          if N_0TO9[m] = c then
            begin
              found := True;
              break;
            end
          else
            begin
              continue
            end;

        end;

        if found then
          begin
{ Counting numbers }
            Inc(count);
            continue
          end
        else
          begin
            break;
          end; { if found then, else }

      end; { for k := 2 to fullLength do }

    end; { if found then }

  Result := count;
end;

function countingNonnumbers(full: String): Integer;
var
  c: Char;
  count: Integer;
  found: Boolean;
  fullLength: Integer;
  k: Integer;
  m: Integer;
  trace: Char;
begin
  c := COMMA_C;
  count := 0;
  fullLength := Length(full);
  trace := c;

  for k := 1 to fullLength do
  begin
    trace := c;
    c := full[k];

{ Checking if a number appears. }
    found := False;
    for m := 1 to N_0TO9_SIZE do
    begin
      if N_0TO9[m] = c then
        begin
          found := True;
          break;
        end
      else
        begin
          continue
        end;

    end;

    if found then
      begin
        break;
      end
    else
      begin
{ Counting nonnumbers }
        Inc(count);
        continue
      end;

  end;

  if trace = MINUS_C then
    begin
      count := count - 1;
    end;

  Result := count;
end;

function trailingNumbers(full: String): Integer;
var
  c: String;
  found: Boolean;
  full_length: Integer;
  k: Integer;
  m: Integer;
  n: Integer;
begin
  full_length := Length(full);
  n := 0;
  for k := full_length downto 1 do
  begin
    c := full[k];

{ Checking if a number appears. }
    found := False;
    for m := 1 to N_0TO9_SIZE do
    begin
      if N_0TO9[m] = c then
        begin
          found := True;
          break;
        end
      else
        begin
          continue
        end;

    end;

    if found then
      begin
        Inc(n);
        continue;
      end
    else
      begin
        break;
      end;

  end;

{ Checking if a number or minus appears. }
  if N_0TO9_MINUS[N_0TO9_MINUS_SIZE] = c then
    begin
      n := n + 1;
    end;

  Result := n;
end;

function extract_decimal(field: String): String;
var
  count: Integer;
  head: String;
  fieldLength: Integer;
  p: Integer;
  r: String;
  tail: String;
  tailLength: Integer;
  trace: Integer;
begin
  p := AnsiPos('.', field);
  if p >= 1 then
    begin
      trace := p;
      p := p - 1;
      head := Copy(field, 1, p);

      fieldLength := Length(field);
      tailLength := fieldLength - trace;
      p := trace + 1;
      tail := Copy(field, p, tailLength);
      count := leadingNumbers(tail);
      if count = 0 then
        begin
          tail := ZERO;
        end
      else
        begin
          tail := Copy(tail, 1, count);
        end;

      count := trailingNumbers(head);
      if count = 0 then
        begin
          head := ZERO;
        end
      else
        begin
          p := trace - count;
          head := Copy(head, p, count);
        end;

      r := Concat(head, '.', tail);
    end
  else
    begin
      r := '0.0';
    end;

  Result := r;
end;

function extract_integer(field: String): String;
var
  r: String;
  count: Integer;
  fieldLength: Integer;
  from: Integer;
  i: Longint;
  p: Integer;
  tail: String;
  tailLength: Integer;
begin
  r := EMPTY;
  fieldLength := Length(field);
  p := countingNonnumbers(field);
  if p = fieldLength then { countingNonnumbers() cannot find any number. }
    begin
      r := ZERO;
    end
  else
    begin
      from := p + 1;
      tailLength := fieldLength - p;
      tail := Copy(field, from, tailLength);
      count := positiveOrNegativeNumbers(tail);
      r := Copy(tail, 1, count);
      if count = 1 then
        begin
          i := Ord(r[1]);
          if i = MINUS_BYTE then
            begin
              r := ZERO;
            end;

        end;

    end;

  Result := r;
end;

function transparent(field: String): String;
begin
  Result := field;
end;

constructor Dividing.Create;
begin
  inherited Create;

  quote_byte := 34; { 22h }
  separator_byte := 44; { 2Ch }
end;

destructor Dividing.Destroy;
begin
  a.Free;

  inherited Destroy;
end;

function Dividing.complementing_fields_list(buffer: array of Char; bufferLength: Integer; extra: String; bond: Byte): Integer;
begin
  smashed_to_pieces(buffer, bufferLength, manyFields);

  vector_to_array_complementing(extra, bond);
  Result := field_count;
end;

function Dividing.editing_field(buffer: array of Char; bufferLength: Integer; field_number: Integer): Integer;
begin
  smashed_to_pieces(buffer, bufferLength, manyFields);

  vector_to_array_editing(transparent, field_number);
  Result := field_count;
end;

function Dividing.fieldCount: Integer;
begin
  Result := field_count;
end;

function Dividing.extracting_decimal_from_field(buffer: array of Char; bufferLength: Integer; field_number: Integer): Integer;
begin
  smashed_to_pieces(buffer, bufferLength, manyFields);

  vector_to_array_editing(extract_decimal, field_number);
  Result := field_count;
end;

function Dividing.extracting_integer_from_field(buffer: array of Char; bufferLength: Integer; field_number: Integer): Integer;
begin
  smashed_to_pieces(buffer, bufferLength, manyFields);

  vector_to_array_editing(extract_integer, field_number);
  Result := field_count;
end;

function Dividing.leadingCharacters(buffer: array of Char; bufferLength: Integer; character: Char): Integer;
var
  c: Char;
  k: Integer;
  bufferLength_1: Integer;
begin
  bufferLength_1 := bufferLength - 1;
  for k := 0 to bufferLength_1 do
  begin
    c := buffer[k];
    if c = character then
      begin
        continue;
      end
    else
      begin
        break;
      end;

  end;

  Result := k;
end;

function Dividing.mapping_fields_list(buffer: array of Char; bufferLength: Integer): Integer;
begin
  smashed_to_pieces(buffer, bufferLength, manyFields);

  vector_to_array_mapping;
  Result := field_count;
end;

function Dividing.quoteCode: Byte;
begin
  Result := quote_byte;
end;

function Dividing.reversing_fields_list(buffer: array of Char; bufferLength: Integer): Integer;
begin
  smashed_to_pieces(buffer, bufferLength, manyFields);

  vector_to_array_arranging_in_reverse_order;
  Result := field_count;
end;

function Dividing.reverse_unite(buffer: array of Char; bufferLength: Integer): String;
var
  item_count_1: Integer;
  n: Integer;
begin
  combo := EMPTY;
  reversing_fields_list(buffer, bufferLength);

  item_count_1 := f.itemCount - 1;
  for n := 0 to item_count_1 do
  begin
    combo := combo + f.item(n);
    combo := combo + separator;
  end;

  Result := combo;
end;

function Dividing.search_separator(buffer: array of Char; bufferLength: Integer; beginning: Integer): Integer;
var
  k: Integer;
  n: Longint;
  no_splitting: Boolean;
  bufferLength_1: Integer;
  r: Integer;
begin
  no_splitting := False;
  bufferLength_1 := bufferLength - 1;
  r := NOT_RECOGNIZED;

  for k := 0 to bufferLength_1 do
  begin
    n := Ord(buffer[k]);

    if no_splitting then
      begin
        if n = quote_byte then
          begin
            no_splitting := False;
          end;

        continue; { Commas disappear if placed in quotes. }
      end;

{ splitting }
    if n = quote_byte then
      begin
        no_splitting := True;
      end
    else
      begin
        if n = separator_byte then
          begin
            r := k;
            break;
          end;

      end;

  end;

  Result := r;
end;

function Dividing.separatorCode: Byte;
begin
  Result := SEPARATOR_BYTE;
end;

function Dividing.smashed_to_pieces(buffer: array of Char; bufferLength: Integer; selected: array of Boolean): Integer;
var
  b: Integer;
  bufferLength_1: Integer;
  c: Char;
  field_number: Integer;
  k: Integer;
  n: Longint;
  no_splitting: Boolean;
  pascal_string: String;
  z: String;
begin
  b := 0;
  field_number := 1;
  no_splitting := False;
  bufferLength_1 := bufferLength - 1;

  for k := 0 to bufferLength_1 do
  begin
    c := buffer[k];
    n := Ord(c);

    if no_splitting then
      begin
        if n = quote_byte then
          begin
            no_splitting := False;
            if selected[field_number] then
              begin
                dough[b] := c;
                Inc(b);
              end;

          end
        else
          begin
            if n = separator_byte then
              begin
                if remove_separators then
                  begin
                    continue; { Commas disappear if placed in quotes. }
                  end
                else
                  begin
                    if selected[field_number] then
                      begin
                        dough[b] := c;
                        Inc(b);
                      end;

                  end;

              end
            else
              begin
                if selected[field_number] then
                  begin
                    dough[b] := c;
                    Inc(b);
                  end;

              end;

          end;

        continue;
      end;

{ splitting }
    if n = quote_byte then
      begin
        no_splitting := True;
        if selected[field_number] then
          begin
            dough[b] := c;
            Inc(b);
          end;

      end
    else
      begin
        if n = separator_byte then
          begin
            if selected[field_number] then
              begin
                pascal_string := dough;
                doughLength := b;
                z := Copy(pascal_string, 1, doughLength);
                a.Add(z);
              end;

            b := 0;
            field_number := field_number + 1;
            if field_number > field_count then
              begin
                break;
              end;

          end
        else
          begin
            if selected[field_number] then
              begin
                dough[b] := c;
                Inc(b);
              end;

          end;

      end;

  end;

  if b > 0 then
    begin
      pascal_string := dough;
      doughLength := b;
      z := Copy(pascal_string, 1, doughLength);
      a.Add(z);
    end
  else
    begin
      field_number := field_number - 1;
    end;

  field_count := field_number;
  Result := b;
end;

function Dividing.supplying_bits(c: Integer): String;
begin
  field_count := c;
  if field_count > UPPER_LIMIT_TO_FIELD_NUMBER then
    field_count := UPPER_LIMIT_TO_FIELD_NUMBER;

  Result := StringOfChar(SET_BIT_C, field_count);
end; 

function Dividing.surge_of_set_bits(c: Integer; interval_0: Integer; interval_1: Integer): String;
var
  body: String;
  bodyLength: Integer;
  head: String;
  headLength: Integer;
  tail: String;
  tailLength: Integer;
  z: String;
begin
{*
  surge_of_set_bits
0011111000000000000, for example
Setting bits from interval_0 to interval_1
*}

  field_count := c;
  if interval_1 > field_count then
    interval_1 := field_count;

  bodyLength := interval_1 - interval_0 + 1;
  body := StringOfChar(SET_BIT_C, bodyLength);

  headLength := interval_0 - 1;
  head := StringOfChar(CLEAR_BIT_C, headLength);

  tailLength := field_count - interval_1;
  tail := StringOfChar(CLEAR_BIT_C, tailLength);

  z := head;
  z := z + body;
  z := z + tail;
  Result := z;
end;

function Dividing.unite(a: TStringList; c: UniversalComboAppend; buffer: array of Char; bufferLength: Integer): String;
var
  item_count_1: Integer;
  n: Integer;
  g: String;
begin
  if a.Count = 0 then
    mapping_fields_list(buffer, bufferLength);

  item_count_1 := f.itemCount - 1;
  for n := 0 to item_count_1 do
  begin
    g := f.item(n);
    c.append(g);
    c.append(separator);
  end;

  size_of_united_items := Length(c.built);
  Result := c.built;
end;

function Dividing.unite(buffer: array of Char; bufferLength: Integer): String;
var
  a_count_1: Integer;
  i: Integer;
begin
  smashed_to_pieces(buffer, bufferLength, manyFields);

  a_count_1 := a.Count - 1;
  combo := EMPTY;
  for i := 0 to a_count_1 do
  begin
    combo := combo + a[i];
    combo := combo + separator;
  end;

  size_of_united_items := Length(combo);
  Result := combo;
end;

function Dividing.unite(buffer: array of Char; bufferLength: Integer; listed: Boolean): String;
var
  item_count_1: Integer;
  n: Integer;
begin
  combo := EMPTY;

  if not listed then
    mapping_fields_list(buffer, bufferLength);

  item_count_1 := f.itemCount - 1;
  for n := 0 to item_count_1 do
  begin
    combo := combo + f.item(n);
    combo := combo + separator;
  end;

  size_of_united_items := Length(combo);
  Result := combo;
end;

function Dividing.unitedSize: Integer;
begin
  Result := size_of_united_items;
end;

procedure Dividing.presetting(s: Byte);
begin
  ascii_byte := UNDERLINE_BYTE;
  joint_byte := UNDERLINE_BYTE;
  quote_byte := STANDARD_QUOTE_BYTE;
  separator_byte := s;
  remove_separators := False;

  ASCII_C := Chr(ascii_byte);
  ascii := EMPTY + ASCII_C;
  JOINT_C := Chr(joint_byte);
  joint := EMPTY + JOINT_C;
  QUOTE_C := Chr(quote_byte);
  quote := EMPTY + QUOTE_C;
  SEPARATOR_C := Chr(separator_byte);
  separator := EMPTY + SEPARATOR_C;

  CLEAR_BIT_C := Chr(CLEAR_BIT);
  COMMA_C := Chr(COMMA_BYTE);
  DOT_C := Chr(H_2E);
  GAP_C := Chr(GAP_BYTE);
  MINUS_C := Chr(MINUS_BYTE);
  SET_BIT_C := Chr(SET_BIT);
end;

procedure Dividing.presetting(q: Byte; s: Byte; e: Boolean);
begin
  ascii_byte := UNDERLINE_BYTE;
  joint_byte := UNDERLINE_BYTE;
  quote_byte := q;
  separator_byte := s;
  remove_separators := e;

  ASCII_C := Chr(ascii_byte);
  ascii := EMPTY + ASCII_C;
  JOINT_C := Chr(joint_byte);
  joint := EMPTY + JOINT_C;
  QUOTE_C := Chr(quote_byte);
  quote := EMPTY + QUOTE_C;
  SEPARATOR_C := Chr(separator_byte);
  separator := EMPTY + SEPARATOR_C;

  CLEAR_BIT_C := Chr(CLEAR_BIT);
  COMMA_C := Chr(COMMA_BYTE);
  DOT_C := Chr(H_2E);
  GAP_C := Chr(GAP_BYTE);
  MINUS_C := Chr(MINUS_BYTE);
  SET_BIT_C := Chr(SET_BIT);
end;

procedure Dividing.presetting(q: Byte; s: Byte; e: Boolean; a: Byte);
begin
  ascii_byte := a;
  joint_byte := UNDERLINE_BYTE;
  quote_byte := q;
  separator_byte := s;
  remove_separators := e;

  ASCII_C := Chr(ascii_byte);
  ascii := EMPTY + ASCII_C;
  JOINT_C := Chr(joint_byte);
  joint := EMPTY + JOINT_C;
  QUOTE_C := Chr(quote_byte);
  quote := EMPTY + QUOTE_C;
  SEPARATOR_C := Chr(separator_byte);
  separator := EMPTY + SEPARATOR_C;

  CLEAR_BIT_C := Chr(CLEAR_BIT);
  COMMA_C := Chr(COMMA_BYTE);
  DOT_C := Chr(H_2E);
  GAP_C := Chr(GAP_BYTE);
  MINUS_C := Chr(MINUS_BYTE);
  SET_BIT_C := Chr(SET_BIT);
end;

procedure Dividing.vector_to_array_arranging_in_reverse_order;
var
  a_count_1: Integer;
  i: Integer;
  k: Integer;
begin
  a_count_1 := a.Count - 1;
  k := a_count_1;
  for i := 0 to a_count_1 do
  begin
    f.setting(a[i], k);
    k := k - 1;
  end;

end;

procedure Dividing.vector_to_array_complementing(extra: String; bond: Byte);
var
  a_count_1: Integer;
  s: String;
  i: Integer;
begin
  a_count_1 := a.Count - 1;
  for i := 0 to a_count_1 do
  begin
    s := a[i];
    s := s + Chr(bond);
    s := s + extra;
    f.setting(s, i);
  end;

end;

procedure Dividing.vector_to_array_editing(editing: EditFunction; field_number: Integer);
var
  a_count_1: Integer;
  field_number_1: Integer;
  i: Integer;
  s: String;
begin
  a_count_1 := a.Count - 1;
  field_number_1 := field_number - 1;
  for i := 0 to a_count_1 do
  begin
    if i = field_number_1 then
      begin
        s := editing(a[i]);
        f.setting(s, i);
      end
    else
      begin
        f.setting(a[i], i);
      end;

  end;

end;

procedure Dividing.vector_to_array_mapping;
var
  a_count_1: Integer;
  i: Integer;
begin
  a_count_1 := a.Count - 1;
  for i := 0 to a_count_1 do
  begin
    f.setting(a[i], i);
  end;

end;

procedure Dividing.setting(fields_list: FieldsListHalt; c: Integer);
var
  m: Integer;
begin
  f := fields_list;
  field_count := c;

  manyFields[0] := True;

  for m:= 1 to field_count do
  begin
    manyFields[m] := True;
  end;

  a := TStringList.Create;
end;

procedure Dividing.setting(fields_list: FieldsListHalt; c: Integer; pn: array of Char);
var
  k: Integer;
  m: Integer;
  n: Longint;
begin
  f := fields_list;
  field_count := c;

  manyFields[0] := True;

  for m:= 1 to field_count do
  begin
    k := m - 1;
    pattern[k] := pn[k];
    n := Ord( pattern[k] );

    if n = SET_BIT then
      manyFields[m] := True
    else
      manyFields[m] := False;

  end;

  a := TStringList.Create;
end;

procedure Dividing.setting_for_extracting;
var
  CLEAR_PETTY_ARRAY: PettyArray;
  k: Integer;
  m: Integer;
  p: PettyArray;
  pascal_string: String;
begin
  for m := 0 to 255 do
  begin
    CLEAR_PETTY_ARRAY[m] := #0;
    p[m] := #0;
  end;

  p := CLEAR_PETTY_ARRAY;
  m := 0;
  for k := H_30 to H_39 do
  begin
    p[m] := Chr(k);
    Inc(m);
  end;

  pascal_string := p;
  N_0TO9 := Copy(pascal_string, 1, N_0TO9_SIZE);

  p[m] := Chr(MINUS_BYTE);
  pascal_string := p;
  N_0TO9_MINUS := Copy(pascal_string, 1, N_0TO9_MINUS_SIZE);
end;

end.
