unit FieldsArray;

interface

uses
  SysUtils;

type
  FieldsList = class
  private
    count: Integer;
    EMPTY_ANSI: AnsiString;
    fields_list: array[0..3071] of AnsiString;
  public
    function item(i: Integer): AnsiString;
    function itemCount: Integer;
    procedure setting(s: AnsiString; i: Integer);
  end;

const
  UPPER_LIMIT_TO_FIELD_NUMBER = 3071;

implementation

function FieldsList.item(i: Integer): AnsiString;
var
  z: AnsiString;
begin
  z := EMPTY_ANSI;

  if i < 0 then
    begin
      Halt(1711);
    end
  else
    begin
      if i >= UPPER_LIMIT_TO_FIELD_NUMBER then
        begin
          Halt(1712);
        end
      else
        begin
          z := fields_list[i];
        end;

    end;

  Result := z;
end;

function FieldsList.itemCount: Integer;
begin
  Result := count;
end;

procedure FieldsList.setting(s: AnsiString; i: Integer);
begin
  EMPTY_ANSI := '';

  if i < 0 then
    begin
      Halt(1713);
    end
  else
    begin
      if i >= UPPER_LIMIT_TO_FIELD_NUMBER then
        begin
          Halt(1714);
        end
      else
        begin
          fields_list[i] := s;
          Inc(count);
        end;

    end;

end;

end.
