unit Guide;

{$I+}

interface

uses
  SysUtils;

type
  Guiding = class
  public
    procedure versionGuide(v: String; comments: Boolean);
  end;

const
  VERSION_TEXT = 'version.txt';

implementation

procedure Guiding.versionGuide(v: String; comments: Boolean);
var
  s: String;
  versionFile: TextFile;
begin
  AssignFile(versionFile, VERSION_TEXT);
  Rewrite(versionFile);
  WriteLn(versionFile, 'Hetn Delphi Version ' + v );
  WriteLn(versionFile, '');
  if comments then
    begin
      WriteLn(versionFile, 'hetn               # Read sutai.txt and arrange lines in ascending order. ');
      WriteLn(versionFile, 'hetn -0            # Every line includes 0Dh. ');
      WriteLn(versionFile, 'hetn --e -o new    # EUC-JP ');
      WriteLn(versionFile, 'hetn -c            # Replace surrogate-pair kanji with Q. ');
      WriteLn(versionFile, 'hetn -E1643 dummy  # Produce messages from the %ERRORLEVEL% value. ');
      WriteLn(versionFile, 'hetn -f            # EIGHT equals eight. ');
      WriteLn(versionFile, 'hetn -G            # Guide ');
      WriteLn(versionFile, 'hetn -LF -o new    # 0Dh is removed from every line. ');
      WriteLn(versionFile, 'hetn -o new        # Read sutai.txt to produce a new file. ');
      WriteLn(versionFile, 'hetn -o-           # Display lines without producing a new file. ');
      WriteLn(versionFile, 'hetn -r            # Arrange lines in descending order. ');
      WriteLn(versionFile, 'hetn -s            # Shift_JIS ');
      WriteLn(versionFile, 'hetn -t -o new     # UTF-16 ');
      WriteLn(versionFile, 'hetn -u            # Display a line for each unique summary. ');
      WriteLn(versionFile, 'hetn -u -!         # Report ID if any summaries match each other. ');
      WriteLn(versionFile, 'hetn -V            # Version ');
    end
  else
    begin
      WriteLn(versionFile, 'hetn --help     ');
    end;

  CloseFile(versionFile);

  AssignFile(versionFile, VERSION_TEXT);
  Reset(versionFile);
  while not Eof(versionFile) do
  begin
    ReadLn(versionFile, s);
    WriteLn(s);
  end;

  CloseFile(versionFile);
end;

end.
