unit FieldsArrayHalt;

interface

uses
  SysUtils;

type
  FieldsListHalt = class
  private
    count: Integer;
    fields_list: array[0..3071] of String;
  public
    function item(i: Integer): String;
    function itemCount: Integer;
    procedure setting(s: String; i: Integer);
  end;

const
  MAXIMUM_FIELD_COUNT = 3071;
  EMPTY = '';

implementation

function FieldsListHalt.item(i: Integer): String;
var
  s: String;
begin
  s := EMPTY;

  if i < 0 then
    begin
      Halt(1454);
    end
  else
    begin
      if i >= MAXIMUM_FIELD_COUNT then
        begin
          Halt(1455);
        end
      else
        begin
          s := fields_list[i];
        end;

    end;

  Result := s;
end;

function FieldsListHalt.itemCount: Integer;
begin
  Result := count;
end;

procedure FieldsListHalt.setting(s: String; i: Integer);
begin
  if i < 0 then
    begin
      Halt(1456);
    end
  else
    begin
      if i >= MAXIMUM_FIELD_COUNT then
        begin
          Halt(1457);
        end
      else
        begin
          fields_list[i] := s;
          Inc(count);
        end;

    end;

end;

end.
