unit VersionForm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ShellAPI;

type
  TForm2 = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Button1: TButton;
    Image1: TImage;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
  private
    PDFname: String;
    versionNumber: String;
  public
    procedure setVersion(p: String; v: String);
  end;

const
  COPYRIGHT = 'Copyright 2020 Sogaya';
  PDF_FILE_NAME = 'Narfi.pdf';
  TITLE = 'Narfi Delphi';
  VERSION_GAP = 'Version ';
  VERSION_HEIGHT = 432;
  VERSION_WIDTH = 295;

var
  Form2: TForm2;

implementation

{$R *.dfm}

procedure TForm2.Button1Click(Sender: TObject);
begin
  ShellExecute(Handle, 'open', PDF_FILE_NAME, nil, nil, SW_NORMAL);
end;

procedure TForm2.FormCreate(Sender: TObject);
begin
  KeyPreview := True;
  BorderIcons := [biSystemMenu];
  Left := ( Screen.Width - VERSION_WIDTH ) div 2;
  Top := ( Screen.Height - VERSION_HEIGHT ) div 2;
  Width := VERSION_WIDTH;
  Height := VERSION_HEIGHT;

  PDFname := PDF_FILE_NAME;
  Label1.Caption := TITLE;
  Label2.Caption := COPYRIGHT;
  Label3.Caption := 'Version 1.0';
end;

procedure TForm2.FormKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  if Key = VK_ESCAPE then
    Close();

end;

procedure TForm2.setVersion(p: String; v: String);
begin
  PDFname := p;
  versionNumber := VERSION_GAP + v;
  Label3.Caption := versionNumber;
end;

end.
