unit FinalEffect;

interface

uses
  SysUtils;

type
  FinalEffects = class
  private
    file_name: String;
    joint_byte: Byte;
    limited_to_value_bytes: Integer;
    limited_to_value_fields: Integer;
    limited_to_value_lines: Integer;
    limited_to_value_rows: Integer;
    no_removing: Boolean;
    separator_byte: Byte;
    wall_value: Integer;
  public
    function behindWall: Integer;
    function fileName: String;
    function jointByte: Byte;
    function noRemoving: Boolean;
    function separatorByte: Byte;
    function valueBytes: Integer;
    function valueFields: Integer;
    function valueLines: Integer;
    function valueRows: Integer;
    procedure setFileName(f: String);
    procedure setting(fn: String;
      vb: Integer; vf: Integer; VL: Integer; vr: Integer; wv: Integer;
      jb: Byte; sb: Byte;
      nr: Boolean);

  end;

implementation

function FinalEffects.behindWall: Integer;
begin
  Result := wall_value;
end;

function FinalEffects.fileName: String;
begin
  Result := file_name;
end;

function FinalEffects.jointByte: Byte;
begin
  Result := joint_byte;
end;

function FinalEffects.noRemoving: Boolean;
begin
  Result := no_removing;
end;

function FinalEffects.separatorByte: Byte;
begin
  Result := separator_byte;
end;

function FinalEffects.valueBytes: Integer;
begin
  Result := limited_to_value_bytes;
end;

function FinalEffects.valueFields: Integer;
begin
  Result := limited_to_value_fields;
end;

function FinalEffects.valueLines: Integer;
begin
  Result := limited_to_value_lines;
end;

function FinalEffects.valueRows: Integer;
begin
  Result := limited_to_value_rows;
end;

procedure FinalEffects.setFileName(f: String);
begin
  file_name := f;
end;

procedure FinalEffects.setting(fn: String;
  vb: Integer; vf: Integer; VL: Integer; vr: Integer; wv: Integer;
  jb: Byte; sb: Byte;
  nr: Boolean);

begin
{ String }
  file_name := fn;

{ Integer }
  limited_to_value_bytes := vb;
  limited_to_value_fields := vf;
  limited_to_value_lines := VL;
  limited_to_value_rows := vr;
  wall_value := wv;

{ Byte }
  joint_byte := jb;
  separator_byte := sb;

{ Boolean }
  no_removing := nr;
end;

end.
