unit Guide;

interface

uses
  SysUtils;

type
  Guiding = class
  public
    procedure versionGuide(v: String; comments: Boolean);
  end;

implementation

procedure Guiding.versionGuide(v: String; comments: Boolean);
begin
  WriteLn( 'Obot Delphi Version ' + v );
  WriteLn('');
  if comments then
    begin
      WriteLn('obot -b2048 text           # Read 2048 bytes. ');
      WriteLn('obot -c20 text             # Produce a table that has 20 fields or less. ');
      WriteLn('obot -G                    # Guide ');
      WriteLn('obot -m3 text              # 3 lines can be represented in hexadecimal as 0D 0A');
      WriteLn('obot -m3 -w127 -j_ text    # __ is the substitute for a number greater than 7Fh');
      WriteLn('obot -m3 -w127 -J\x7C text # || is the substitute for a number greater than 7Fh');
      WriteLn('obot -m3 -s, text          # CSV ');
      WriteLn('obot -m3 -S\x2C text       # CSV ');
      WriteLn('obot -m45 -r20 text        # Produce a table that has 20 rows or less. ');
      WriteLn('obot exe                   # EXE can be represented in hexadecimal as 4D 5A... ');
      WriteLn('obot -V                    # Version ');
      WriteLn('obot -y < text             # Do not remove text.tmp ');
    end
  else
    begin
      WriteLn('obot -b2048 text           ');
      WriteLn('obot -c20 text             ');
      WriteLn('obot -G                    ');
      WriteLn('obot -m3 text              ');
      WriteLn('obot -m3 -w127 -j_ text    ');
      WriteLn('obot -m3 -w127 -J\x7C text ');
      WriteLn('obot -m3 -s, text          ');
      WriteLn('obot -m3 -S\x2C text       ');
      WriteLn('obot -m45 -r20 text        ');
      WriteLn('obot exe                   ');
      WriteLn('obot -V                    ');
      WriteLn('obot -y < text             ');
    end;

end;

end.
