unit Guide;

interface

uses
  SysUtils;

type
  Guiding = class
  public
    procedure versionGuide(v: String; comments: Boolean);
  end;

implementation

procedure Guiding.versionGuide(v: String; comments: Boolean);
begin
  WriteLn( 'Rufeol Delphi Version ' + v );
  WriteLn('');
  if comments then
    begin
      WriteLn('rufeol -d csv          # Display data. ');
      WriteLn('rufeol -G              # Guide ');
      WriteLn('rufeol -m csv          # Remove a separator from every end of line. ');
      WriteLn('rufeol -u3 csv         # Remove 3 characters from every end of line.');
      WriteLn('rufeol -u3 csv new     # Read csv to produce a new file. ');
      WriteLn('rufeol -u3 -o new csv  # Read csv to produce a new file. ');
      WriteLn('rufeol -u3 -0 csv      # Every line includes 0Dh. ');
      WriteLn('rufeol -u3 -b csv csv  # Produce and rename binary.tmp ');
      WriteLn('rufeol -u3 -b -y csv   # Do not remove binary.tmp ');
      WriteLn('rufeol -u3 -L csv      # 0Dh is removed from every line. ');
      WriteLn('rufeol -u3 -r csv      # Every line includes 0Dh. ');
      WriteLn('rufeol -u3 -t csv new  # CSV has the same time as the new text. ');
      WriteLn('rufeol -u3 -w2 -r text # Read a double-spaced text to produce a draft. ');
      WriteLn('rufeol -x2 text        # Read a double-spaced text to produce a draft. ');
      WriteLn('rufeol -V              # Version ');
    end
  else
    begin
      WriteLn('rufeol -d csv          ');
      WriteLn('rufeol -G              ');
      WriteLn('rufeol -m csv          ');
      WriteLn('rufeol -u3 csv         ');
      WriteLn('rufeol -u3 csv new     ');
      WriteLn('rufeol -u3 -o new csv  ');
      WriteLn('rufeol -u3 -0 csv      ');
      WriteLn('rufeol -u3 -b csv csv  ');
      WriteLn('rufeol -u3 -b -y csv   ');
      WriteLn('rufeol -u3 -L csv      ');
      WriteLn('rufeol -u3 -r csv      ');
      WriteLn('rufeol -u3 -t csv new  ');
      WriteLn('rufeol -u3 -w2 -r text ');
      WriteLn('rufeol -x2 text        ');
      WriteLn('rufeol -V              ');
    end;

end;

end.
