unit Guide;

interface

uses
  SysUtils;

type
  Guiding = class
  public
    procedure versionGuide(v: String; comments: Boolean);
  end;

const
  VERSION_TEXT = 'version.txt';

implementation

procedure Guiding.versionGuide(v: String; comments: Boolean);
begin
  WriteLn( 'Sjiseuc Delphi Version ' + v );
  WriteLn('');
  if comments then
    begin
      WriteLn('sjiseuc SJIS            # Produce sjiseuc.txt ');
      WriteLn('sjiseuc SJIS EUC        # Produce a new file. ');
      WriteLn('sjiseuc -o EUC SJIS     # Produce a new file. ');
      WriteLn('sjiseuc -o EUC < SJIS   # Every line includes 0Dh. ');
      WriteLn('sjiseuc -0 SJIS         # Every line includes 0Dh. ');
      WriteLn('sjiseuc -t SJIS EUC     # SJIS has the same time as EUC. ');
      WriteLn('sjiseuc -a SJIS         # Acquire a table name from set_sjiseuc.txt ');
      WriteLn('sjiseuc -b SJIS         # Produce binary.tmp ');
      WriteLn('sjiseuc -b SJIS SJIS    # Produce and rename binary.tmp ');
      WriteLn('sjiseuc -b -y SJIS      # Do not remove binary.tmp ');
      WriteLn('sjiseuc -d SJIS         # Do not search a table. ');
      WriteLn('sjiseuc -G              # Guide ');
      WriteLn('sjiseuc -LF SJIS        # 0Dh is removed from every line. ');
      WriteLn('sjiseuc -s SJIS         # Remove control characters. ');
      WriteLn('sjiseuc -w SJIS         # -w shows which table sjiseuc uses.');
      WriteLn('sjiseuc -V              # Version ');
    end
  else
    begin
      WriteLn('sjiseuc SJIS            ');
      WriteLn('sjiseuc SJIS EUC        ');
      WriteLn('sjiseuc -o EUC SJIS     ');
      WriteLn('sjiseuc -o EUC < SJIS   ');
      WriteLn('sjiseuc -0 SJIS         ');
      WriteLn('sjiseuc -t SJIS EUC     ');
      WriteLn('sjiseuc -a SJIS         ');
      WriteLn('sjiseuc -b SJIS         ');
      WriteLn('sjiseuc -b SJIS SJIS    ');
      WriteLn('sjiseuc -b -y SJIS      ');
      WriteLn('sjiseuc -d SJIS         ');
      WriteLn('sjiseuc -G              ');
      WriteLn('sjiseuc -LF SJIS        ');
      WriteLn('sjiseuc -s SJIS         ');
      WriteLn('sjiseuc -w SJIS         ');
      WriteLn('sjiseuc -V              ');
    end;

end;

end.
