unit FieldsArray;

interface

uses
  SysUtils, ErrorText;

type
  FieldsList = class
  private
    count: Integer;
    fields_list: array[0..3071] of String;
  public
    function item(i: Integer): String;
    function itemCount: Integer;
    procedure setting(s: String; i: Integer);
  end;

const
  C_ERR = 'err';
  MAXIMUM_FIELD_COUNT = 3071;
  EMPTY = '';
  TEXT_FILE = '.txt';

implementation

function FieldsList.item(i: Integer): String;
var
  x: ErrorTexts;
  s: String;
begin
  s := EMPTY;

  if i < 0 then
    begin
      x := ErrorTexts.Create;
      x.setting(C_ERR, TEXT_FILE, 'item() error-602: i < 0');
      x.Free;
    end
  else
    begin
      if i >= MAXIMUM_FIELD_COUNT then
        begin
          x := ErrorTexts.Create;
          x.setting(C_ERR, TEXT_FILE, 'item() error-603: >= MAXIMUM_FIELD_COUNT');
          x.Free;
        end
      else
        begin
          s := fields_list[i];
        end;

    end;

  Result := s;
end;

function FieldsList.itemCount: Integer;
begin
  Result := count;
end;

procedure FieldsList.setting(s: String; i: Integer);
var
  x: ErrorTexts;
begin
  if i < 0 then
    begin
      x := ErrorTexts.Create;
      x.setting(C_ERR, TEXT_FILE, 'item() error-604: i < 0');
      x.Free;
    end
  else
    begin
      if i >= MAXIMUM_FIELD_COUNT then
        begin
          x := ErrorTexts.Create;
          x.setting(C_ERR, TEXT_FILE, 'item() error-605: >= MAXIMUM_FIELD_COUNT');
          x.Free;
        end
      else
        begin
          fields_list[i] := s;
          Inc(count);
        end;

    end;

end;

end.
