unit FinalEffect;

interface

uses
  SysUtils;

type
  FinalEffects = class
  private
    adding_ID: Boolean;
    carriage_return: Boolean;
    case_insensitive: Boolean;
    descending_order: Boolean;
    euc_jp: Boolean;
    extracting_decimal: Boolean;
    extracting_integer: Boolean;
    field_count: Integer;
    file_name: String;
    focal_point: Integer;
    interval_from: Integer;
    interval_to: Integer;
    joint_byte: Byte;
    label_byte: Byte;
    large_number: Currency;
    manage: Integer;
    maximum_number_of_fields: Integer;
    maximum_number_of_lines: Integer;
    new_name: String;
    no_checking: Boolean;
    no_combining: Boolean;
    no_removing: Boolean;
    no_searching: Boolean;
    pattern: String;
    pattern_expressed_as_binary_numbers: Boolean;
    path_name: String;
    quote_byte: Byte;
    report_line_numbers: Boolean;
    selected_directory_has_priority: Boolean;
    separator_byte: Byte;
    setting_text: Boolean;
    shared_sum: Boolean;
    shift_jis_text: Boolean;
    skip_separators: Boolean;
    skip_wide_space: Boolean;
    substituted: Boolean;
    surrogate_pair_to_underline: Boolean;
    unique_summary: Boolean;
    UTF16_text: Boolean;
    which_table: Boolean;
  public
    function addingID: Boolean;
    function atPoint: Integer;
    function carriageReturn: Boolean;
    function descendingOrder: Boolean;
    function EUC_JP_file: Boolean;
    function extractDecimal: Boolean;
    function extractInteger: Boolean;
    function fieldCount: Integer;
    function fileName: String;
    function intervalFrom: Integer;
    function intervalTo: Integer;
    function jointByte: Byte;
    function labelByte: Byte;
    function largeValue: Currency;
    function manager: Integer;
    function maximumFieldCount: Integer;
    function maximumLineCount: Integer;
    function multipleBitPattern: String;
    function newName: String;
    function noChecking: Boolean;
    function noCombining: Boolean;
    function noRemoving: Boolean;
    function noSearching: Boolean;
    function notCaseSensitive: Boolean;
    function pathName: String;
    function patternRepresented: Boolean;
    function priority: Boolean;
    function produceSettingText: Boolean;
    function quoteByte: Byte;
    function reportLineNumbers: Boolean;
    function removeSeparators: Boolean;
    function Shift_JIS_file: Boolean;
    function skipWideSpace: Boolean;
    function separatorByte: Byte;
    function sharedSum: Boolean;
    function substituteForDakuten: Boolean;
    function surrogatePairToUnderline: Boolean;
    function uniqueSummary: Boolean;
    function upperLimit: Integer;
    function UTF16_file: Boolean;
    function whichTable: Boolean;
    procedure setting; overload;
    procedure setting(fn: String; nn: String; pn: String; p: String;
      ln: Currency;
      fc: Integer; fp: Integer; im: Integer; io: Integer; m: Integer; mf: Integer; ML: Integer;
      jb: Byte; LB: Byte; qb: Byte; sb: Byte;
      ai: Boolean; pe: Boolean; cr: Boolean; cs: Boolean; dr: Boolean; ed: Boolean; ei: Boolean; ej: Boolean; nc: Boolean; ng: Boolean; nr: Boolean; ns: Boolean; RL: Boolean; sd: Boolean; sj: Boolean; sp: Boolean; st: Boolean; sm: Boolean; ss: Boolean; sw: Boolean; SUB: Boolean; us: Boolean; ut: Boolean; wt: Boolean); overload;

  end;

const
  FINAL_INTEGER = 2147483647; { 7FFFFFFFh }

implementation

function FinalEffects.addingID: Boolean;
begin
  Result := adding_ID;
end;

function FinalEffects.atPoint: Integer;
begin
  Result := focal_point;
end;

function FinalEffects.carriageReturn: Boolean;
begin
  Result := carriage_return;
end;

function FinalEffects.descendingOrder: Boolean;
begin
  Result := descending_order;
end;

function FinalEffects.extractDecimal: Boolean;
begin
  Result := extracting_decimal;
end;

function FinalEffects.EUC_JP_file: Boolean;
begin
  Result := euc_jp;
end;

function FinalEffects.extractInteger: Boolean;
begin
  Result := extracting_integer;
end;

function FinalEffects.fieldCount: Integer;
begin
  Result := field_count;
end;

function FinalEffects.fileName: String;
begin
  Result := file_name;
end;

function FinalEffects.intervalFrom: Integer;
begin
  Result := interval_from;
end;

function FinalEffects.intervalTo: Integer;
begin
  Result := interval_to;
end;

function FinalEffects.jointByte: Byte;
begin
  Result := joint_byte;
end;

function FinalEffects.labelByte: Byte;
begin
  Result := label_byte;
end;

function FinalEffects.largeValue: Currency;
begin
  Result := large_number;
end;

function FinalEffects.manager: Integer;
begin
  Result := manage;
end;

function FinalEffects.maximumFieldCount: Integer;
begin
  Result := maximum_number_of_fields;
end;

function FinalEffects.maximumLineCount: Integer;
begin
  Result := maximum_number_of_lines;
end;

function FinalEffects.multipleBitPattern: String;
begin
  Result := pattern;
end;

function FinalEffects.newName: String;
begin
  Result := new_name;
end;

function FinalEffects.noChecking: Boolean;
begin
  Result := no_checking;
end;

function FinalEffects.noCombining: Boolean;
begin
  Result := no_combining;
end;

function FinalEffects.noRemoving: Boolean;
begin
  Result := no_removing;
end;

function FinalEffects.noSearching: Boolean;
begin
  Result := no_searching;
end;

function FinalEffects.notCaseSensitive: Boolean;
begin
  Result := case_insensitive;
end;

function FinalEffects.pathName: String;
begin
  Result := path_name;
end;

function FinalEffects.patternRepresented: Boolean;
begin
  Result := pattern_expressed_as_binary_numbers;
end;

function FinalEffects.priority: Boolean;
begin
  Result := selected_directory_has_priority;
end;

function FinalEffects.produceSettingText: Boolean;
begin
  Result := setting_text;
end;

function FinalEffects.quoteByte: Byte;
begin
  Result := quote_byte;
end;

function FinalEffects.separatorByte: Byte;
begin
  Result := separator_byte;
end;

function FinalEffects.sharedSum: Boolean;
begin
  Result := shared_sum;
end;

function FinalEffects.reportLineNumbers: Boolean;
begin
  Result := report_line_numbers;
end;

function FinalEffects.removeSeparators: Boolean;
begin
  Result := skip_separators;
end;

function FinalEffects.Shift_JIS_file: Boolean;
begin
  Result := shift_jis_text;
end;

function FinalEffects.skipWideSpace: Boolean;
begin
  Result := skip_wide_space;
end;

function FinalEffects.substituteForDakuten: Boolean;
begin
  Result := substituted;
end;

function FinalEffects.surrogatePairToUnderline: Boolean;
begin
  Result := surrogate_pair_to_underline;
end;

function FinalEffects.uniqueSummary: Boolean;
begin
  Result := unique_summary;
end;

function FinalEffects.upperLimit: Integer;
begin
  Result := maximum_number_of_fields;
end;

function FinalEffects.UTF16_file: Boolean;
begin
  Result := UTF16_text;
end;

function FinalEffects.whichTable: Boolean;
begin
  Result := which_table;
end;

procedure FinalEffects.setting;
begin
{ String }
  file_name := '';
  new_name := '';
  path_name := '';
  pattern := '1111111111111111';

{ Currency }
  large_number := 562949953421312.0001;

{ Integer }
  field_count := 16;
  interval_from := 1;
  interval_to := 1;
  manage := 0;
  maximum_number_of_fields := 3071;
  maximum_number_of_lines := FINAL_INTEGER;

{ Byte }
  joint_byte := 124; { | }
  label_byte := 60; { < }
  quote_byte := 34; { " }
  separator_byte := 44; { , }

{ Boolean }
  adding_ID := False;
  carriage_return := True;
  case_insensitive := True;
  descending_order := False;
  extracting_decimal := False;
  extracting_integer := False;
  no_checking := False;
  no_combining := False;
  no_removing := False;
  no_searching := False;
  pattern_expressed_as_binary_numbers := False;
  report_line_numbers := False;
  selected_directory_has_priority := False;
  setting_text := False;
  shared_sum := False;
  shift_jis_text := True;
  skip_separators := False;
  skip_wide_space := False;
  substituted := False;
  unique_summary := False;
  which_table := False;
end;

procedure FinalEffects.setting(fn: String; nn: String; pn: String; p: String;
  ln: Currency; 
  fc: Integer; fp: Integer; im: Integer; io: Integer; m: Integer; mf: Integer; ML: Integer;
  jb: Byte; LB: Byte; qb: Byte; sb: Byte;
  ai: Boolean; pe: Boolean; cr: Boolean; cs: Boolean; dr: Boolean; ed: Boolean; ei: Boolean; ej: Boolean; nc: Boolean; ng: Boolean; nr: Boolean; ns: Boolean; RL: Boolean; sd: Boolean; sj: Boolean; sp: Boolean; st: Boolean; sm: Boolean; ss: Boolean; sw: Boolean; SUB: Boolean; us: Boolean; ut: Boolean; wt: Boolean);

begin
{ String }
  file_name := fn;
  new_name := nn;
  path_name := pn;
  pattern := p;

{ Currency }
  large_number := ln;

{ Integer }
  field_count := fc;
  focal_point := fp;
  interval_from := im;
  interval_to := io;
  manage := m;
  maximum_number_of_fields := mf;
  maximum_number_of_lines := ML;

{ Byte }
  joint_byte := jb;
  label_byte := LB;
  quote_byte := qb;
  separator_byte := sb;

{ Boolean }
  adding_ID := ai;
  carriage_return := cr;
  case_insensitive := cs;
  descending_order := dr;
  euc_jp := ej;
  extracting_decimal := ed;
  extracting_integer := ei;
  no_checking := nc;
  no_combining := ng;
  no_removing := nr;
  no_searching := ns;
  pattern_expressed_as_binary_numbers := pe;
  report_line_numbers := RL;
  selected_directory_has_priority := sd;
  shift_jis_text := sj;
  
  setting_text := st;
  shared_sum := sm;
  skip_separators := ss;
  skip_wide_space := sw;
  substituted := SUB;
  surrogate_pair_to_underline := sp;
  unique_summary := us;
  UTF16_text := ut;
  which_table := wt;
end;

end.
