unit ReportID;

interface

uses
  SysUtils, MessagesText;

type
  CheckID = class
  private
    h: Integer;
    id: array[1..128] of Integer;
    uniqueID: array[1..128] of String;
  public
    function report_id(k: Integer): Integer;
    function report_unique_ID(k: Integer): String;
    procedure consistent;
    procedure displayID;
    procedure presetting;
    procedure setting(i: Integer); overload;
    procedure setting(u: String); overload;
  end;

const
  ERROR_CODE = -1;
  EMPTY = '';
  LIMIT_OF_MY_MEMORY = 128;
  NOT_CONVERTED = -1;

implementation

function CheckID.report_id(k: Integer): Integer;
var
  r: Integer;
begin
  r := ERROR_CODE;

  if k <= LIMIT_OF_MY_MEMORY then
    begin
      if k >= 1 then
        begin
          r := id[k];
        end;

    end;

  Result := r;
end;

function CheckID.report_unique_ID(k: Integer): String;
var
  r: String;
begin
  r := EMPTY;

  if k <= LIMIT_OF_MY_MEMORY then
    begin
      if k >= 1 then
        begin
          r := uniqueID[k];
        end;

    end;

  Result := r;
end;

procedure CheckID.consistent;
var
  k: Integer;
begin
  for k := 1 to LIMIT_OF_MY_MEMORY do
  begin
    if id[k] > 0 then
      begin
        uniqueID[k] := IntToStr(id[k]);
      end
    else
      begin
        uniqueID[k] := EMPTY;
      end;

  end;

end;

procedure CheckID.displayID;
var
  k: Integer;
begin
  for k := 1 to LIMIT_OF_MY_MEMORY do
  begin
    if id[k] > 0 then
      begin
        Write('Line-');
        WriteLn( IntToStr(id[k]) );
      end;

  end;

end;

procedure CheckID.presetting;
var
  k: Integer;
begin
  h := 1;

  for k := 1 to LIMIT_OF_MY_MEMORY do
  begin
    id[k] := 0;
    uniqueID[k] := EMPTY;
  end;

end;

procedure CheckID.setting(i: Integer);
begin
  id[h] := i;
  Inc(h);

  if h > LIMIT_OF_MY_MEMORY then
    h := 1;

end;

procedure CheckID.setting(u: String);
begin
  uniqueID[h] := u;
  Inc(h);

  if h > LIMIT_OF_MY_MEMORY then
    h := 1;

end;

end.
