unit Guide;

interface

uses
  SysUtils;

type
  Guiding = class
  public
    procedure versionGuide(v: String; comments: Boolean);
  end;

const
  VERSION_TEXT = 'version.txt';

implementation

procedure Guiding.versionGuide(v: String; comments: Boolean);
begin
  WriteLn( 'Utf16euc Version ' + v );
  WriteLn('');
  if comments then
    begin
      WriteLn('utf16euc                 # Produce UTF16~EUC-JP.bin ');
      WriteLn('utf16euc UTF16           # Produce utf16euc.txt ');
      WriteLn('utf16euc UTF16 EUC       # Produce a new file. ');
      WriteLn('utf16euc -o EUC UTF16    # Produce a new file. ');
      WriteLn('utf16euc -0 UTF16        # Every line includes 0Dh. ');
      WriteLn('utf16euc -t UTF16 EUC    # UTF16 has the same time as EUC. ');
      WriteLn('utf16euc -a UTF16        # Acquire a table name from set_utf16euc.txt ');
      WriteLn('utf16euc -b UTF16        # Produce binary.tmp ');
      WriteLn('utf16euc -b UTF16 UTF16  # Produce and rename binary.tmp ');
      WriteLn('utf16euc -b -y UTF16     # Do not remove binary.tmp ');
      WriteLn('utf16euc -d UTF16        # Do not search a table. ');
      WriteLn('utf16euc -G              # Guide ');
      WriteLn('utf16euc -LF UTF16       # 0Dh is removed from every line. ');
      WriteLn('utf16euc -r2 UTF16 EUC   # Select Field-2 from UTF16 to produce EUC. ');
      WriteLn('utf16euc -s UTF16        # Remove control characters. ');
      WriteLn('utf16euc -u UTF16        # Replace surrogate-pair kanji with Q. ');
      WriteLn('utf16euc -w UTF16        # -w shows which table utf16euc uses.');
      WriteLn('utf16euc -V              # Version ');
    end
  else
    begin
      WriteLn('utf16euc                 ');
      WriteLn('utf16euc UTF16           ');
      WriteLn('utf16euc UTF16 EUC       ');
      WriteLn('utf16euc -o EUC UTF16    ');
      WriteLn('utf16euc -0 UTF16        ');
      WriteLn('utf16euc -t UTF16 EUC    ');
      WriteLn('utf16euc -a UTF16        ');
      WriteLn('utf16euc -b UTF16        ');
      WriteLn('utf16euc -b UTF16 UTF16  ');
      WriteLn('utf16euc -b -y UTF16     ');
      WriteLn('utf16euc -d UTF16        ');
      WriteLn('utf16euc -G              ');
      WriteLn('utf16euc -LF UTF16       ');
      WriteLn('utf16euc -r2 UTF16 EUC   ');
      WriteLn('utf16euc -s UTF16        ');
      WriteLn('utf16euc -u UTF16        ');
      WriteLn('utf16euc -w UTF16        ');
      WriteLn('utf16euc -V              ');
    end;

end;

end.
